--[[

   Simple Slot Blocking - V1.0

   This script will remove a player from an aircraft if the mission script has the Simple Slot Blocking script included
   and the aircraft is currently on the disabled list.

   NOTE: Currently I can't figure out how to access scripts running in the mission from here so it works by using flag values.

   The unit ID is used to access a flag and if the flag is set to 1 then that unit / slot is disabled

   You can get the unit IDs by looking in the mission or using a script to dump them all

 ]]

local ssbCallbacks = {}
ssbCallbacks.version = 1.5

ssbCallbacks.onSimulationFrame = function ()
--net.log("START TRIGGER")
	if DCS.getModelTime()> 1 then
		ssbCallbacks.timer()
	end
end

ssbCallbacks.timer = function()
	local curTime = DCS.getModelTime()
	--net.log(curTime%5)
	if (curTime % 5) * 1000 < 10 then
		ssbCallbacks.checkState()
		net.log(curTime)
	end
	--ssbCallbacks.timer()
end

ssbCallbacks.checkState = function ()
	--if DCS.getModelTime() > 1 then
		net.log("test1")
		local curPlayerList = net.get_player_list()
		net.log(table.getn(curPlayerList))
		for j = 1,#curPlayerList do
			net.log("ID is "..curPlayerList[j])
			local curPlayerID = curPlayerList[j]
			net.log("cur ID is "..curPlayerID)
			
				local curPlayerSide,curPlayerSlot = net.get_slot(curPlayerID)
				local curPlayerName = net.get_player_info(curPlayerID, 'name')
				local curUnitID = ssbCallbacks.getUnitId(curPlayerSlot)
				net.log("Current Slot is" ..curUnitID)
				--local curPlayCheck = net.dostring_in('server', "return sb.checkExist("..curPlayerName..","..curUnitID..","..curPlayerSide..")")
				if curUnitID ~= nil then
					local curPlayCheck,_error  = net.dostring_in('server', " return trigger.misc.getUserFlag("..curUnitID.."); ")
					net.log(curPlayCheck)
					if not curPlayCheck and _error then
						net.log("error getting flag: ".._error)
						return true
					elseif tonumber(curPlayCheck) == 1 then
						--if curPlayCheck == false then
							ssbCallbacks.rejectPlayer(curPlayerID)
					end
				end
			net.dostring_in('server', " return trigger.misc.setUserFlag("..curUnitID..",0); ")
			end
			
		end

-- Logic for determining if player is allowed in a slot
-- function ssbCallbacks.shouldAllowSlot(_playerID, _slotID) -- _slotID == Unit ID unless its multi aircraft in which case slotID is unitId_seatID


    -- local _unitId = ssbCallbacks.getUnitId(_slotID);

    -- local _status,_error  = net.dostring_in('server', " return trigger.misc.getUserFlag(".._unitId.."); ")

    -- if not _status and _error then
        -- net.log("error getting flag: ".._error)
        -- return true
    -- else
      -- --  net.log("flag value ".._unitId.." value: ".._status)

        -- --disabled
        -- if tonumber(_status) == 1 then
            -- return false
        -- else
            -- return true
        -- end
    -- end

-- end

-- _slotID == Unit ID unless its multi aircraft in which case slotID is unitId_seatID
function ssbCallbacks.getUnitId(_slotID)
    local _unitId = tostring(_slotID)
    if string.find(tostring(_unitId),"_",1,true) then
        --extract substring
        _unitId = string.sub(_unitId,1,string.find(_unitId,"_",1,true))
        net.log("Unit ID Substr ".._unitId)
    end

    return tonumber(_unitId)
end



--DOC
-- onGameEvent(eventName,arg1,arg2,arg3,arg4)
--"friendly_fire", playerID, weaponName, victimPlayerID
--"mission_end", winner, msg
--"kill", killerPlayerID, killerUnitType, killerSide, victimPlayerID, victimUnitType, victimSide, weaponName
--"self_kill", playerID
--"change_slot", playerID, slotID, prevSide
--"connect", id, name
--"disconnect", ID_, name, playerSide
--"crash", playerID, unit_missionID
--"eject", playerID, unit_missionID
--"takeoff", playerID, unit_missionID, airdromeName
--"landing", playerID, unit_missionID, airdromeName
--"pilot_death", playerID, unit_missionID
--
-- ssbCallbacks.onGameEvent = function(eventName,playerID,arg2,arg3,arg4) -- This stops the user flying again after crashing or other events

    -- if  DCS.isServer() and DCS.isMultiplayer() then
        -- if DCS.getModelTime() > 1 then  -- must check this to prevent a possible CTD by using a_do_script before the game is ready to use a_do_script. -- Source GRIMES :)

            -- if eventName ~= "connect"
                    -- and eventName ~= "disconnect"
                    -- and eventName ~= "mission_end"
                    -- and eventName ~=  "change_slot" then

                -- -- is player in a slot and valid?
                -- local _playerDetails = net.get_player_info(playerID)

                -- if _playerDetails ~=nil and _playerDetails.side ~= 0 and _playerDetails.slot ~= "" and _playerDetails.slot ~= nil then

                    -- local _allow = ssbCallbacks.shouldAllowSlot(playerID, _playerDetails.slot)

                    -- if not _allow then
                        -- --ssbCallbacks.rejectPlayer(playerID)
                    -- end

                -- end
            -- end
        -- end
    -- end
-- end

-- ssbCallbacks.onTriggerText = function(message, duration, clearView)
-- net.send_chat("TRIGGER", true)
-- end

-- ssbCallbacks.onPlayerTryChangeSlot = function(playerID, side, slotID)


        -- if  (side ~=0 and  slotID ~='' and slotID ~= nil)  then

            -- local _allow = ssbCallbacks.shouldAllowSlot(playerID,slotID)

            -- if not _allow then
               -- -- ssbCallbacks.rejectPlayer(playerID)

                -- return false
            -- end
        -- end

        -- net.log("allowing -  playerid: "..playerID.." side:"..side.." slot: "..slotID)


    -- return true

-- end

ssbCallbacks.rejectPlayer = function(playerID)
    net.log("Reject Slot - force spectators - "..playerID)

    -- put to spectators
    net.force_player_slot(playerID, 0, '')

    local _playerName = net.get_player_info(playerID, 'name')

    if _playerName ~= nil then
        --Disable chat message to user
        local _chatMessage = string.format("*** Sorry %s, this Slot is currently DISABLED ***",_playerName)
        net.send_chat_to(_chatMessage, playerID)
    end
end

ssbCallbacks.trimStr = function(_str)

    return  string.format( "%s", _str:match( "^%s*(.-)%s*$" ) )
end

DCS.setUserCallbacks(ssbCallbacks)

net.log("Loaded - Simple Slot Block v"..ssbCallbacks.version.. " by Ciribob")
